/*****************************************************************/
/* 			sde.h                                    */
/*****************************************************************/
#define MAXBOUNDS 500
/*estructura que almacena la informacion del individuo */
typedef struct individuo{
	double *x;   /* decision variables*/
	double *f;    /* objective function */
	double *c;    /* constraints */
	double fitness; /* fitness */
	double sumviol; /* sum of constraint violation */
	int numviol;   /* number of violated constraints  (not used in DDE)*/
	int feasible; /* feasible (1) infeasible (0) */
	double normfitness; /* normalized fitness (not used in DDE) */
} tindividual;

/* function headers */
void warmup_random(float);
float randomperc();
void randomize();
int flip(float);
void advance_random();
void cls();
double Gauss(double sigma);
double N(double m, double sigma);
void initrandom(int seed);
double randreal(void);
int randint(int,int);
void memory_allocation();
void free_all();
void lee_archivo(char *);
float rndreal(float,float);
void initialize_pop();
void genera_nueva_poblacion(int);
void copia(tindividual *, tindividual *);
void nomemory(char *);
void imprime_ind(tindividual *);;
void imprime_pob(tindividual *,int );
void statistics(tindividual *,int);
void report();
void muta_y_recombina(int);
int selecti(int);
void obtiene_mejor(int);



void objfunc1(tindividual *);
void objfunc2(tindividual *);
void objfunc3(tindividual *);
void objfunc4(tindividual *);
void objfunc5(tindividual *);
void objfunc6(tindividual *);
void objfunc7(tindividual *);
void objfunc8(tindividual *);
void objfunc9(tindividual *);
void objfunc10(tindividual *);
void objfunc11(tindividual *);
void objfunc12(tindividual *);
void objfunc13(tindividual *);
void objfunc14(tindividual *);
void objfunc15(tindividual *);
void objfunc16(tindividual *);
void objfunc17(tindividual *);
void objfunc18(tindividual *);
void objfunc19(tindividual *);
void objfunc20(tindividual *);
void objfunc21(tindividual *);
void objfunc22(tindividual *);
void objfunc23(tindividual *);
void objfunc24(tindividual *);
/* ADD YOUR NEW FUNCTION HEADER 
   EXAMPLE:
void objfunc25(tindividual *); 
*/



int NP;
int GMAX;			   /* max generations */
double F,CR;			   /* DE operator parameters*/
double EPSILON;
double SR;
int NOFFSPRING;
float  Rseed;	    		   /* Random Seed */

double oldrand[55];                /* 55 random numbers*/
int jrand;                         /* current random number */
int t;				   /* current generation number */
int n;				   /* number of decision variables*/
int nfunc;			   /* Number of objective functions (1)*/
int nrestric;			   /* Number of constraints */
tindividual *parents;		   /* Parents population */
tindividual *childs;		   /* Offspring population */
tindividual *temporal;		   /* temporal population */
tindividual thebest,oneoffspring;  /* the best solution so far */

int posofthebest;		   /* index in the population of the best */
float semilla_a_reportar;          /* Initial random seed*/
float bounds[2][MAXBOUNDS];    	   /* Decision variable limits*/
int datos_entrada;
double sumfitness,facpercent,pftotal,min,max,avg;
int nofacxgen;
FILE *salida;
int filesize;
int mnf_p,mnf_h;
